
#include "stdio.h"
#include "conio.h"

// prende un numero intero e ne fa' il doppio
int doppio(int n)
{
    asm
    {
        MOV EAX,n      // carica n in EAX (entrambi a 32 bit)
        MOV EBX,2      // carica 2 in EBX
        // effettua una moltiplicazione tra EBX e EAX (fattore implicito)
        // ossia moltiplica EBX per 2
        MUL EBX
    }

    return(_EAX);      // ritorna EAX (dove  stato cumulato il risultato)
}

// prende un intero e ne fa' il complemento a 2
int complemento2(int n)
{
   asm  {
       MOV EAX,n    // carica n in EAX (entrambi a 32 bit)
       NOT EAX         // inverte i bit di EAX (porta a 1 se 0 in origine e viceversa)
       INC EAX      // incrementa di 1 EAX, completando il complemento a 2 su EAX
   }

   return(_EAX);       // rende il complemento contenuto in EAX
}

// assume una stringa (vettore di caratteri) e
// individua la prima evenienza di una specifica lettera
int trova_primo(char v[], char chr)
{
   asm  {
      MOV EBX,v       // inizializza EBX a puntare alla posizione di inizio del vettore v
      MOV ESI,0          // pone il registro indice ESI a 0 (punter agli elementi via via successivi)
      Ciclo:
      // muove l'elemento puntato da ESI in CL per successivo confronto
      // (CMP non ammette il tipo di indirizzamento indiretto indicizzato, memoria)
      MOV CL,Byte Ptr[EBX + ESI]
      CMP CL,chr          // compara CL a chr (carattere cercato)
      JE Trovato      // se uguale vuol dire che  stato trovato
      INC ESI               // altrimenti:  passa ad analizzare il carattere successivo
      CMP Byte Ptr[EBX + ESI],0   // controlla se si  raggiunta la fine della stringa (car. '\0')
      JNE Ciclo        // se non  un '\0' allora cerca ancora
      JMP Non_Trovato    // altrimenti significa che non  stato trovato e salta opportunamente
      Trovato:
   }

   return(_ESI + 1);     // se trovato rende la posizione ESI incrementata di 1

   asm  {
      Non_Trovato:
   }
   return(-1);     // ritorna il valore -1 indicante la non presenza del carattere chr
}

// assunto in ingresso un vettore di interi
// ne calcola la somma degli elementi
int somma_vett(int v[], int d)
{
   asm  {
      MOV EBX,v    // inizializza EBX a puntare alla posizione di inizio del vettore v
      MOV ESI,0      // pone il registro indice ESI a 0 (punter agli elementi via via successivi)
      MOV EAX,0
      Ciclo:
      // prende l'elemento (intero) del vettore di posizione ESI e lo
      // aggiunge ad EAX (totalizzatore)
      ADD EAX,DWord Ptr[EBX + (ESI * 4)]
      INC ESI      // incrementa di 1 ESI
      CMP ESI,d      // controlla se ESI  pari alla dimensione del vettore
      JNE Ciclo    // se non lo  cicla, altrimenti no
   }

   return(_EAX);     // rende il valore di EAX, ossia il totale della somma
}

// main per test delle funzioni assembly
void main()
{
   char st[20], car;
   int vett[10] = {3,2,1,5,6,3,8,9,6,7};

   printf("Test funzione assembly per calcolo del doppio:\n");
   printf("Il doppio di %i risulta %i  ",23452, doppio(23452));

   printf("\n\nTest funzione per il calcolo del complemento a 2:\n");
   printf("Il complemento a due di %i risulta %i  ",23452, complemento2(23452));

   printf("\n\nTest per la ricerca della prima posizione di un carattere in una stringa:\n"); 
   printf("Leggi stringa:  ");
   gets(st);

   car = 't';
   printf("Il carattere '%c' appare nella stringa per la prima volta in %i.", car, trova_primo(st,car));

   printf("\n\nTest della somma di tutti gli elementi di un vettore (di interi):\n"); 
   printf("La somma di tutti gli elementi del vettore vett risulta: %i",somma_vett(vett,10));

   getch();

}
